%define	dosver	1.0

#disable for plugins
%define _disable_ld_no_undefined 1

Summary:	DOSEMU allows you to to run DOS programs
Name:		dosemu
Version:	1.4.0.8
Release:	%mkrel 5
License:	GPLv2+
Group:		Emulators
Url:		http://dosemu.sourceforge.net/
Source0:	%{name}-%{version}.tar.xz
Source1:	%{name}-freedos-%{dosver}-bin.tar.bz2
Source11:	xdosemu-16x16.png
Source12:	xdosemu-32x32.png
Source13:	xdosemu-48x48.png
Patch0:		dosemu-skip-glibc-test.patch
Patch1:     dosemu-LTO-fix.patch

BuildRequires:	bison
BuildRequires:	flex
BuildRequires:	bdftopcf
BuildRequires:	mkfontdir
BuildRequires:	pkgconfig(x11)
BuildRequires:	svgalib-devel
BuildRequires:	pkgconfig(xext)
BuildRequires:	pkgconfig(xxf86vm)
BuildRequires:	pkgconfig(slang)
BuildRequires:	pkgconfig(sdl2)
Requires:	dosimage

%description
DOSEMU is a user-level program which uses certain special features
of the Linux kernel and the 80386 processor to run MS-DOS/FreeDOS/
DR-DOS, DOS programs, and many DPMI applications in what we in the
biz call a `DOS box'.

%package -n	xdosemu
Summary:	A DOS emulator for the X Window System
Group:		Emulators
Requires:	dosimage
Requires:	%{name} >= %{version}-%{release}

%description -n	xdosemu
Xdosemu is a version of the dosemu DOS emulator that runs with the X
Window System.  Xdosemu provides VGA graphics and mouse support.

Install xdosemu if you need to run DOS programs on your system, and you'd
like to do so with the convenience of graphics support and mouse
capabilities.

%package	freedos
Summary:	A FreeDOS hdimage for dosemu, a DOS emulator, to use
Group:		Emulators
Provides:	dosimage
Requires:	%{name} >= %{version}-%{release}

%description	freedos
Generally, the dosemu DOS emulator requires either that your system
have some version of DOS available or that your system's partitions
were formatted and installed with DOS. If your system does not meet
either of the previous requirements, you can instead use the dosemu-
freedos package, which contains required files which will be
installed in '/usr/share/dosemu/freedos-1.0'

Install dosemu-freedos if you are installing the dosemu package
and you don't have a version of DOS available on your system,
and your system's partitions were not formatted and installed
with DOS.

%prep
%setup -c %{name} -q -n %{name}-%{version}
bunzip2 -c %{SOURCE1} | gzip -c > freedos.tgz
%apply_patches

%build
autoreconf -vfi
export CFLAGS="%{optflags} -fgnu89-inline"
%configure2_5x	--with-fdtarball=freedos.tgz \
		--with-svgalib \
		--with-x
# Parallel build does not work and puttin 'make -jX' will break build on ARM
make -j1

%install
%make_install

mkdir -p %{buildroot}%{_iconsdir}/hicolor/{16x16,32x32,48x48}/apps
install -m644 %{SOURCE11} -D \
	%{buildroot}%{_iconsdir}/hicolor/16x16/apps/x%{name}.png
install -m644 %{SOURCE12} -D \
	%{buildroot}%{_iconsdir}/hicolor/32x32/apps/x%{name}.png
install -m644 %{SOURCE13} -D \
	%{buildroot}%{_iconsdir}/hicolor/48x48/apps/x%{name}.png

#xdg menu
mkdir -p %{buildroot}%{_datadir}/applications
cat > %{buildroot}%{_datadir}/applications/x%{name}.desktop <<EOF
[Desktop Entry]
Name=Xdosemu
Comment=DOS emulator running under X
Exec=x%{name}
Icon=x%{name}
Terminal=false
Type=Application
Categories=Emulator;
EOF

rm -rf %{buildroot}%{_docdir}

# move freedos to another place to fix update issue (#34837)
mv %{buildroot}%{_datadir}/%{name}/freedos \
 %{buildroot}%{_datadir}/%{name}/freedos-%{dosver}

%files
%doc doc/*
%{_bindir}/%{name}.bin
%{_bindir}/%{name}
%{_bindir}/mkfatimage
%{_bindir}/mkfatimage16
%{_bindir}/midid
%{_bindir}/dosdebug
%{_libdir}/%{name}/libplugin*.so
%{_mandir}/man1/mkfatimage16.1*
%{_mandir}/man1/dosdebug.1*
%{_mandir}/man1/%{name}.1*
%{_mandir}/man1/%{name}.bin.1*
%{_mandir}/man1/midid.1.*
%lang(ru) %{_mandir}/ru/man1/mkfatimage16.1*
%lang(ru) %{_mandir}/ru/man1/dosdebug.1*
%lang(ru) %{_mandir}/ru/man1/%{name}.1*
%lang(ru) %{_mandir}/ru/man1/%{name}.bin.1*
%dir %{_datadir}/%{name}
%{_datadir}/%{name}/commands
%{_datadir}/%{name}/keymap
%{_datadir}/%{name}/Xfonts
%config(noreplace) %{_sysconfdir}/%{name}.conf
%config(noreplace) %{_sysconfdir}/drives/c
%config(noreplace) %{_sysconfdir}/drives/d
%config(noreplace) %{_sysconfdir}/%{name}.users
%config(noreplace) %{_sysconfdir}/global.conf

%files -n x%{name}
%{_bindir}/x%{name}
%{_mandir}/man1/x%{name}.1*
%lang(ru) %{_mandir}/ru/man1/x%{name}.1*
%{_iconsdir}/hicolor/16x16/apps/x%{name}.png
%{_iconsdir}/hicolor/32x32/apps/x%{name}.png
%{_iconsdir}/hicolor/48x48/apps/x%{name}.png
%{_datadir}/applications/x%{name}.desktop

%files freedos
%{_datadir}/%{name}/freedos-%{dosver}
%{_datadir}/%{name}/drive_z


%changelog
* Wed Oct 27 2021 yodelu - 1.4.0.8-5pclos2021
- add p6

* Wed Oct 20 2021 tex - 1.4.0.8-4pclos2021
- rebuild against updates

* Fri Oct 15 2021 tex - 1.4.0.8-3pclos2021
- rebuild new fluidsynth
